// 01-03-2014
// OK en mode Texte 4 ligne de 16 gros carateres
// Ne fonctionne pas en mode image
// ne fonctionne pas en mode graphique pixel
// 28-02-2014
// Attention au reglage tres pointu du contraste
// il semble que le potar CMS repr VR soit l pour regler le contraste..
// mais insuffisant (alim=5V), rajout d'un potar externe aliment entre +5 et 0V,
// avec curseur -->2,7K -->Pin 3 LCD reperee NC (mais regalge contraste sur autre source d'info!)
// links:
//http://tutorial.cytron.com.my/2012/01/02/graphic-lcd-st7920-interfacing-to-skpic32/
//   MCU          : PIC18F26k22  28 pins
//   FOSC         : interne 8MHZ
//   Project      : 18F26K22_LCD128x64.mcp
//   Program Name : 18F26k22_ST7920_128x64_test_140301.c
//   Programer    : pf
//   Create date  : Version 0.0   140227
//   LastUpdate   : 140301
//   History      :
//   Langage      : MPLAB C18 V3.45 
//   linker file  : 18f26k22_LCD128x64.lkr

// options compilo C18:-Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-  -nw=2066 -pa=3 -nw=2054

/*
DATABANK NAME=memoryGDRAM START=0x500 END=0x90F  	PROTECTED
SECTION NAME=memoryGDRAM RAM=memoryGDRAM
DATABANK NAME=memoryFONT START=0xA00 END=0xDFF  	PROTECTED
SECTION NAME=memoryFONT RAM=memoryFONT
extrait de MAP file : 18F26K22_ST7920_128x64.map
 memoryGDRAM      udata   0x000500       data   0x000402
 memoryFONT      idata   0x000a00       data   0x000400
 
*/
/* =========== HARDWARE ====================

*  Digole 12864w with ST7920 
                                  

 Pin 1 ------------> Gnd         
 Pin 2 ------------> +5volts         
 Pin 3 ------------> NC ? Contrast -- 2,7-- curseur potar contrast           
 Pin 4 ------------> Register Select        RS 
 Pin 5 ------------> Read/Write             RW
 Pin 6 ------------> Enable                 EN
 Pin 7-14 ---------> Data bits  
 Pin 15 -----------> PSB (parallel=high & serial=low) 
 Pin 16 -----------> NoConnection   
 Pin 17 -----------> Reset                  /RST
 Pin 18 -----------> Vout  
 Pin 19 -----------> +5volts 
 Pin 20 -----------> Gnd  
 using 8bit parallel operation for optimal RAM 


PIC 18F26K22  microchip 

Interface pour liaison UART TTL <-> RS232 19200 bauds
PortB
B0  21  -> SG12864(Data0)       7       marron
B1  22  -> SG12864(Data1)       8
B2  23  -> SG12864(Data2)       9
B3  24  -> SG12864(Data3)       10
B4  25  -> SG12864(Data4)       11
B5  26  -> SG12864(Data5)       12
B6  27  -> SG12864(Data6)       13
B7  28  -> SG12864(Data7)       14      gris
B6  27  ----1K-----ICSP CLCK
B7  28  ----1K-----ICSP DATA
MCLR    -----------ICSP VPP

PORTC
C0   11  -> SG12864(E)          6
C1   12  -> SG12864(R/W)        5
C2   13  -> SG12864(RS)         4
C3   14  -> SG12864(/RST)       17
C4   15                         15  PSB -- +5V
C5   16  NC
C6   17  Uart1 Serial PORT(Tx) -> MAX3222 avec alim 3,3V
C7   18  * optional Uart1 Serial PORT(Rx) <- MAX3222 avec alim 3,3V

PORTA
A0   2
A1   3
A2   4
A3   5 
A4   6 ---> R + Led rouge--+5V
A5   7

*/

#include	<p18f26k22.h>
#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<math.h>
#include	<ctype.h>
#include	<io.h>
#include	<adc.h>

#include "Delay16M/Delays_16Mhz.h"
#include "../_common/UART1/Uart1.h"
//#include "ST7920_GRAPHICS.c" 

#define OSCILLATEUR_INTERNE

#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSHP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF
#endif

#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF   

// config vue par pickit2 : 2800 3C19 9D00 0084 C00F E00F 400F 
/*
#define   LCD_E     LATCbits.LATC0    // vert       pin 6  Enable    
#define   LCD_RW    LATCbits.LATC1    // jaune      pin 5  0=Write 1=Read 
#define   LCD_RS      LATCbits.LATC2  // orange     pin 4  RS 1= data  0=instruction or busy flag test
#define   LCD_RESET   LATCbits.LATC3  // violet     pin 17 /RESET Low active
#define   PSB       1                 // bleu       pin 15 PSB=1 (VCC) =parallele mode   0=Serial mode
#define   LCD_Data  LATB              // pins 7-Marron .... 14-gris  Data bus
#define   LCD_Port   PORTB             // read data from LCD  
*/
#define   e     LATCbits.LATC0        
#define   rw    LATCbits.LATC1
#define   rs    LATCbits.LATC2  // DI  Register Select pin4
#define   rst   LATCbits.LATC3  // /ReSeT pin17
#define   LCD_Data  LATB
#define   LCD_Port   PORTB 
#define input(PIN_B7)  PORTBbits.RB7


#define ON   1 
#define OFF   0 
#define XVAL 16  // 16 X 16 or 256 for there is 8 word values for the upper and lower 
#define YVAL 32 
#define GLCD_WIDTH   128

#define   Led_Rouge LATAbits.LATA4

#define Clear  0x01
#define Home   0x02

unsigned int i,j,k,l,m;
unsigned int AC; // adresse counter
unsigned char TEXTE[32];
unsigned char *txt;

typedef union 
{ 
  unsigned int word;            // size =2 bytes
  unsigned char nbyte[2];       // size =2 bytes
} Dots; 

#pragma udata memoryGDRAM

typedef struct // size = 2*16*32+2=1024+2 = 1026 => 0x0402h
{ 
  int refresh; 
  Dots pix[YVAL][XVAL];   // Max dimensions for display (x,y) = (128,32) 
  } GD_RAM;               //  (0,0) corresponds to upper lefthand corner. 
GD_RAM gdram; 
#pragma udata

#pragma idata memoryFONT

//------------------------------------------------------------------------------
// File generated by LCD Assistant
// http://en.radzio.dxp.pl/bitmap_converter/
//------------------------------------------------------------------------------

static unsigned char graphic [] = { // size =64*16 =1024=400h {
0x00, 0x80, 0x00, 0x40, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x10, 0x30, 0x30, 0x30, 0x30, 0x70, 0x60, 0x60, 0x60, 0xE0,
0xE0, 0xE0, 0xC0, 0xC0, 0xC0, 0xC0, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xE0,
0xF0, 0xF8, 0xFC, 0xFC, 0x7E, 0x7E, 0x7E, 0xFE, 0xFC, 0xF8, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF0, 0xF8, 0x1C,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x01, 0x01, 0x01, 0x03, 0x03, 0x07, 0x07, 0x0F, 0x1F, 0x1F, 0x3F, 0x7E, 0xFE, 0xFC, 0xFC,
0xFC, 0xF8, 0xB8, 0x30, 0x20, 0x60, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xFC, 0xFF, 0xFF,
0x3F, 0x07, 0x01, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x07, 0x07, 0x00, 0x00, 0xFF, 0xFF, 0xFF,
0x00, 0x00, 0xC0, 0xF8, 0xFE, 0xFF, 0x3F, 0x0F, 0x12, 0xFE, 0xFF, 0xFF, 0xFF, 0x3F, 0x3F, 0x1F,
0x80, 0xF8, 0xFF, 0xFF, 0xFF, 0x7E, 0x3F, 0x3F, 0x1F, 0xE2, 0xF8, 0xFC, 0xFE, 0x7F, 0x3F, 0x1F,
0x3F, 0xFF, 0xFE, 0xFC, 0xE0, 0x00, 0x00, 0xC0, 0xFE, 0xFF, 0xFF, 0x7F, 0x3E, 0x1F, 0xFF, 0xFF,
0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x03,
0x07, 0x0F, 0x3F, 0xFE, 0xF8, 0xE0, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
0xC0, 0x80, 0xC0, 0xC0, 0xF0, 0xFC, 0xFC, 0xFC, 0x3C, 0x00, 0x00, 0x00, 0xF8, 0xFF, 0xFF, 0xFF,
0xFC, 0xFF, 0x7F, 0x1F, 0x07, 0x01, 0x00, 0x80, 0xFC, 0xFF, 0xFF, 0xFF, 0x83, 0x00, 0x00, 0xF8,
0xFF, 0xFF, 0x7F, 0x07, 0x00, 0x00, 0x00, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 0x81, 0x80, 0xC0, 0xE0,
0xFC, 0xFF, 0xFF, 0x3F, 0x03, 0xC0, 0xFC, 0xFF, 0xFF, 0x3F, 0x03, 0x00, 0xC0, 0xFC, 0xFF, 0xFF,
0x3F, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x03, 0x01, 0x00, 0x00, 0xE0, 0xC0, 0xE0, 0xFF, 0xFF, 0xFF, 0x3F,
0x0F, 0x03, 0x80, 0x80, 0x80, 0x80, 0x00, 0x03, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x0F, 0x0F,
0x0F, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F,
0x07, 0x03, 0x00, 0x00, 0x00, 0x0F, 0x0F, 0x0F, 0x03, 0x00, 0x00, 0x04, 0x0F, 0x0F, 0x0F, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xC0,
0xE0, 0xF0, 0x78, 0x3F, 0x1F, 0x07, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x07, 0x07, 0x07, 0x03, 0x00, 0x00,
0x00, 0x00, 0x01, 0xFF, 0x01, 0x01, 0xF8, 0xB4, 0xB4, 0x18, 0x70, 0x8C, 0x84, 0x4C, 0xC0, 0x1F,
0x04, 0xFC, 0x00, 0xFC, 0x04, 0xFC, 0x00, 0xF8, 0x8C, 0x84, 0x7C, 0x80, 0x3F, 0x70, 0x8C, 0x84,
0xFC, 0x00, 0xF8, 0x84, 0xEC, 0x0C, 0xF0, 0x05, 0xF8, 0xBC, 0xB4, 0x18, 0xC0, 0xBC, 0xF4, 0xEC,
0xC0, 0x40, 0x40, 0x60, 0x20, 0x30, 0x30, 0x18, 0x18, 0x08, 0x0C, 0x06, 0x06, 0x03, 0x03, 0x01,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x40, 0xC0, 0x80, 0x00, 0x00, 0xC0, 0x40,
0x40, 0xC0, 0x00, 0x00, 0x80, 0xC0, 0xC0, 0xC1, 0x80, 0x00, 0x80, 0xC1, 0x41, 0xC0, 0xC0, 0x00,
0x00, 0xC0, 0xC0, 0xC0, 0x40, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x80, 0x00, 0x01, 0x01,
0xC0, 0x02, 0x06, 0xC7, 0xC3, 0xC0, 0x40, 0x00, 0x00, 0x81, 0xC0, 0x80, 0x00, 0x01, 0x01, 0xC0,
0x40, 0xC0, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0x40, 0x00, 0xC0, 0x40, 0x40,
0xC0, 0x80, 0x00, 0x00, 0x00, 0x00, 0x40, 0xC0, 0xC0, 0x40, 0x00, 0x00, 0xC0, 0x40, 0x40, 0xC0,
0x00, 0x00, 0x80, 0xC0, 0xC0, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x03, 0x03, 0x07, 0x01, 0x00, 0x07, 0x06, 0x04,
0x04, 0x07, 0x00, 0x00, 0x07, 0x05, 0x05, 0x07, 0x00, 0x00, 0x07, 0x04, 0x04, 0x04, 0x03, 0x00,
0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x01, 0x01, 0x07,
0x03, 0x00, 0x04, 0x07, 0x05, 0x04, 0x00, 0x00, 0x06, 0x03, 0x02, 0x07, 0x00, 0x00, 0x07, 0x04,
0x04, 0x04, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x02, 0x07, 0x04, 0x04,
0x07, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x01, 0x00, 0x00, 0x07, 0x04, 0x04, 0x04, 0x07,
0x00, 0x00, 0x07, 0x05, 0x04, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00
//, 0x00, 0x00, 0x00, 0x00, 0x00
};



#pragma idata

#pragma udata

unsigned char glcd_read_data (void); 
void glcd_write_data(unsigned char x); 
void glcd_check_busy(void); 
void glcd_Cde(unsigned char x);
//void glcd_fillScreen(unsigned int color) ;
void glcd_update (void);
void glcd_init_graph(void);
void glcd_init_basic(void);
void glcd_pixel(unsigned char x, unsigned char y, int color) ;
void glcd_plot_image(int width,int height,int x,int y,int inverse); 
//----------------------
void Init_UART1(void);
void Put_RS( unsigned char  untel);
void PutStr_RS( unsigned char *s);
void PutStrR_RS(const rom  char *s);
void PutR_RS( const rom  char * untel);
void CRLF(void);
void Tempo(long L);
//----- ADC 10 bit ------
void Init_ADC(void);
unsigned int Mesure_ADC(int j) ; // utilise buffer pointe par txt

void set_CGRAM_adress(int x,int y)
{
 glcd_Cde(0x40+ x&0x3F); 
 glcd_Cde(0x40+ y & 0x0F);   
}    

void set_DDRAM_adress(int x,int y)
{
 glcd_Cde(0x80+x);  
 glcd_Cde(0x80+y); 
}
 
unsigned char glcd_read_data (void) 
{ 
   unsigned char data;   // Stores the data read from the LCD 
  rs=1;
  rw=1;//Set for reading 
  TRISB=0xFF;
  e=1; // GLCD_E = 1; 
  Delay_uS(1); 
  data=PORTB;      // Get the data from the display's output register 
  TRISB=0x00;
  e=0;//GLCD_E = 0; 
  return (data); 
} 

  
void glcd_check_busy(){ 
   int busy=1; 
   rs=0;      // LOW RS and High RW will put the lcd to 
   rw=1;      // read busy flag and address counter 
   TRISB=0XFF;
   while(busy)
   {         // will cycle until busy flag is 0 
      e=1; 
      if(!input(PIN_B7)){ 
      busy=0; 
    } 
    e=0; 
    TRISB=0x00;
   } 
} 
  
void glcd_Cde(unsigned char x){ 
    Delay_uS(1); 
   //glcd_check_busy();  
   rs=0;    // Write instruction mode  
    Delay_uS(1);  
   rw=0;   
    Delay_uS(1);  
   e=1;      
   Delay_uS(1);  
   LCD_Data=x;         // 8bit data to bus 
   Delay_uS(1);        
   e=0;      // disable 
} 

void glcd_write_data(unsigned char x){ 
   Delay_uS(15);   
   //glcd_check_busy(); 
   rs=1;     // Write data mode  
    Delay_uS(1);
   rw=0;      
    Delay_uS(1);
   e=1; 
   Delay_uS(1); 
   LCD_Data=x; 
   Delay_uS(1); 
   e=0; 
   Delay_uS(1); 
} 


void glcd_init_graph(){ 
   Delay_mS(50); 
   rst=0;         //reset LCD 
   Delay_mS(150);                      
   rst=1;        //LCD normal operation 
   glcd_Cde(0x30);   //set 8 bit operation and basic instruction set 
   Delay_uS(200); 
 //  glcd_Cde(0x0F);   //Display ON , Cursor ON , Blink ON 
   glcd_Cde(0x08);   //Display ON , Cursor Off , Blink Off 
   Delay_uS(100); 
   glcd_Cde(0x01);   //display clear 
   Delay_mS(50); 
   glcd_Cde(0x06);   //entry mode set 
   Delay_uS(100);                  
  glcd_Cde(0x34);    // Select DL=1=8bits interface extended instruction set. 
  Delay_mS (10); 
  glcd_Cde(0x36);    // Graphic display ON. 
  Delay_mS (10); 
  
} 

void glcd_init_basic()
{ 
   Delay_mS(40); 
   rst=0;         //reset LCD 
   Delay_uS(10);                      
   rst=1;        //LCD normal operation 
   glcd_Cde(0x30);   //set 8 bit operation and basic instruction set 
   Delay_uS(200); 
   glcd_Cde(0x08);   //Display on, Cursor off , Blink off 
   Delay_uS(100); 
   glcd_Cde(0x01);   //display clear 
   Delay_mS(50); 
   glcd_Cde(0x06);   //entry mode set 
   Delay_uS(100);                  
} 

void bit_clear(unsigned char x, unsigned char y)
{
  x=x & y;  
}

void bit_set(unsigned char x,unsigned char y ) 
{
 x=x | y;   
}    

unsigned int bit_test(unsigned int x,unsigned int y ) 
{
    int z;
    z=x & y;
    if (z>0) return(1); else return(0);
} 


void glcd_pixel(unsigned char x, unsigned char y, int color) 
{ 
  unsigned char v, h, b; 
  if(y>31){x += 128; y-= 32;}; 
  v = y; 
  h = x/16; 
  b = 15 - (x%16); 
  if (color >0) 
     {
        gdram.pix[v][h].nbyte[1]=gdram.pix[v][h].nbyte[1] | b; 
        gdram.pix[v][h].nbyte[0]=gdram.pix[v][h].nbyte[0] | b; 
       }    
  else 
    {
     gdram.pix[v][h].nbyte[1]=gdram.pix[v][h].nbyte[1] & b; 
      gdram.pix[v][h].nbyte[0]=gdram.pix[v][h].nbyte[0] & b; 
       }  
} 

/*
void glcd_plot_image(int width,int height,int x,int y,int inverse) 
{ 
   unsigned int i=0, j=0, k=0; 
  unsigned int count=0; 
   //glcd_fillScreen(OFF);                        //Clears the screen (opt.) 
   for(j=0;j<height;j++) 
      {    
         for(;i<width;) 
         { 
            for(k=8;k>0;k--){ 
               if(inverse)glcd_pixel(i+x,j+y,~bit_test(graphic[count],(k-1))); 
               else glcd_pixel(i+x,j+y,bit_test(graphic[count],(k-1))); 
                
               i++; 
            } 
            count++; 
         } 
      i=0; 
      } 
} 
*/

void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0bits.ADON=1;      // ADC enabled chanel 0
 ADCON1bits.TRIGSEL=0 ; // trigger from CCP5
 ADCON2bits.ADFM=1;     // right justified
 ADCON2bits.ACQT2=1;
 ADCON2bits.ACQT1=1;
 ADCON2bits.ACQT0=0;    // 16 TAD
 ADCON2bits.ADCS1=1;    // select RA0 = analog input
 ADCON2bits.ADCS2=0;    // RA1 = Analog input
 ADCON2bits.ADCS0=0;    // Fosc/32
 ADCON1bits.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1bits.PVCFG0=0;
 ADCON1bits.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1bits.NVCFG0=0;
 }


 unsigned int Mesure_ADC(int j) // utilise buffer pointe par txt
{
  unsigned int M0,k1;
  //ADCON0bits.ADON=1;
  ADCON0=1 + (j<<2);   // ADON=1 et choix de canal
  Delay_uS(50 ); // Delay for 100TCY
  ConvertADC(); // Start conversion
  while( BusyADC() );
  M0 = ReadADC(); // Read result
//  itoa(M0,txt);
//  Put_RS('M');Put_RS(j+48);Put_RS('=');
//  k1=PutStr_RS(txt);
//  Tempo(5000L);
  return (M0);
}

void Init_Hardware()
 {
   ANSELB=0;
   PORTB = 0x00;
   TRISB = 0x00;
   //TRISBbits.TRISB6 ICPS CLOCK;  
   //TRISBbits.TRISB7 ICSP DATA; 

      // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
  ANSELA=1;               // RA0= analog input on Port A
  TRISA = 0b00000111 ;   // PORTA  RA1,2,= Digital input  RA3,4,5=Digital output
  LATA = 0x00;
  
  ANSELC=0;
  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0b10000000;    // all output expect RC7
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 0;
  TRISCbits.TRISC3 = 0;
  TRISCbits.TRISC4 = 0;
  TRISCbits.TRISC5 = 0;
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  
  SLRCON=0;
 }


void _GLCDWrite(unsigned char col, unsigned char row, unsigned char inpChr)
{
	switch (row) {
        case 0:
            col |= 0x80;
            break;
        case 1:
            col |= 0x90;
            break;
        case 2:
            col |= 0x88;
            break;
        case 3:
            col |= 0x98;
            break;
        default:
            col |= 0x80;
            break;
    }

    glcd_Cde(col);
	glcd_write_data(inpChr); 
}	

void _GLCD_FillScreenGraphic( unsigned char* graphic)
{
	unsigned char x, y;
	unsigned int z;
	for(y = 0; y < 64; y++)
	{
		if(y < 32)
		{
			for(x = 0; x < 8; x++)				// Draws top half of the screen.
			{									// In extended instruction mode, vertical and horizontal coordinates must be specified before sending data in.
				glcd_Cde(0x80 | y);				// Vertical coordinate of the screen is specified first. (0-31)
    			glcd_Cde(0x80 | x);				// Then horizontal coordinate of the screen is specified. (0-8)
		        z=	2*x + 16*y;
				glcd_write_data(graphic[z]);		// Data to the upper byte is sent to the coordinate.
				 z++;
				glcd_write_data(graphic[z]);	// Data to the lower byte is sent to the coordinate.
			}
		}
		else
		{
			for(x = 0; x < 8; x++)				// Draws bottom half of the screen.
			{									// Actions performed as same as the upper half screen.
				glcd_Cde(0x80 | (y-32));		// Vertical coordinate must be scaled back to 0-31 as it is dealing with another half of the screen.
    			glcd_Cde(0x88 | x);
    			z=	2*x + 16*y;
				glcd_write_data(graphic[z]);
				z++;
				glcd_write_data(graphic[z]);
			}
		}
		
	}
}



void _GLCD_ClearGraphics()
{
	// zeros are sent into the screen instead of data from an array.
	unsigned char x, y;
	for(y = 0; y < 64; y++)
	{
		if(y < 32)
		{
			glcd_Cde(0x80 | y);
    		glcd_Cde(0x80);
		}
		else
		{
			glcd_Cde(0x80 | (y-32));
    		glcd_Cde(0x88);
		}
		for(x = 0; x < 8; x++)
		{
			glcd_write_data(0x00);
			glcd_write_data(0x00);
		}
	}
} 

void _GLCDWriteText(unsigned char col, unsigned char row, char* string)
{
    switch (row) {
        case 0:
            col |= 0x80;
            break;
        case 1:
            col |= 0x90;
            break;
        case 2:
            col |= 0x88;
            break;
        case 3:
            col |= 0x98;
            break;
        default:
            col |= 0x80;
            break;
    }
   glcd_Cde(col);
   while (*string)
   glcd_write_data(*string++);
     
}

void _GLCD_EnableGraphics()
{
    glcd_Cde(0x08);     //Display, cursor and blink are ALL OFF		
	Delay_mS(1);
	glcd_Cde(0x30);		// RE=0  DL=1 mode 8 bits
	Delay_mS(1);
	glcd_Cde(0x34);			// Switch to extended instruction mode.	RE=1
	Delay_mS(1);
	glcd_Cde(0x36);			// Enable graphics mode. RE=1
	Delay_mS(1);
}

void _GLCD_DisableGraphics()
{
	glcd_Cde(0x30);			// Graphics extended instruction off &  8bits data
	Delay_mS(1);
}

void glcd_update () 
{ 
  unsigned char v, h; 
  if (gdram.refresh==1) 
  { 
    for (v=0; v <YVAL; v++) 
    { 
      glcd_Cde( 0x80 | v);   // Set Vertical Address. 
      glcd_Cde( 0x80 | 0);   // Set Horizontal Address. 
      for (h=0; h <XVAL; h++) 
      { 
        glcd_write_data( gdram.pix[v][h].nbyte[1]);   // Write High Byte. 
        glcd_write_data(  gdram.pix[v][h].nbyte[0]);   // Write Low Byte. 
      } 
    } 
    gdram.refresh = 0; 
  } 
} 



void main(void)
{        
#ifdef OSCILLATEUR_INTERNE
 // OSCCON=0x70;         // Select 16 MHz internal clock  et 19200 bds
 OSCCON=0x60;         // Select 8 MHz internal clock  et 9600 bds
 //   OSCCON=0x50;         // Select 4 MHz internal clock et 4800bds
 //   OSCCON=0x40;         // Select 2 MHz internal clock et 2400bds
 //   OSCCON=0x30;         // Select 1 MHz internal clock et 1200bds
#endif
    Init_Hardware() ;
    Led_Rouge=1;
    Init_UART1();   //  19200,8,N,1
    Put_RS(12); //CLS
    Delay_mS(300);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test SG12862 GLCD \r\nInit UART1 9600bds at 8Mhz \r\n"); 
    Init_ADC();
    k=fprintf(_H_USART,(const rom unsigned char *)"Init ADC1 sur RA0 \r\n"); 
    k=fprintf(_H_USART,(const rom unsigned char *)"Init LCD \r\n"); 
    Led_Rouge=0;
    k=fprintf(_H_USART,(const rom unsigned char *)"Sizeof struct GDRAM  %5d \r\n",sizeof(gdram)); 
    Delay_xS(4);
    
     glcd_init_basic();
 
     
  while(1)
    { 
    glcd_Cde(Clear);
    glcd_Cde(Home); 

    k=fprintf(_H_USART,(const rom unsigned char *)"Mode Texte\r\n"); 
      
    sprintf(txt,(const rom unsigned char *)"Hello World!    "); 
    _GLCDWriteText(0, 0, txt);
     sprintf(txt,(const rom unsigned char *)"This is 18F26K22"); 
     _GLCDWriteText(0, 1, txt);
     sprintf(txt,(const rom unsigned char *)"1234567890123456"); 
     _GLCDWriteText(0, 2,txt);
     sprintf(txt,(const rom unsigned char *)"AaBbCcDdZz?!#.,&"); 
  	_GLCDWriteText(0, 3,txt);
     Delay_xS(4); 
     glcd_Cde(Clear); // clear mode texte
     
     k=fprintf(_H_USART,(const rom unsigned char *)"Mode Grafic\r\n"); 
     _GLCD_EnableGraphics();
     _GLCD_ClearGraphics(); // clear mode grafic
     _GLCD_FillScreenGraphic(graphic);
     //_GLCD_FillScreenGraphic(LM35_pinout);
     Delay_xS(4); 
      
   // probleme affichage pixel

     _GLCD_ClearGraphics();
     _GLCD_EnableGraphics();
     for (i=0;i<120;i++)
     {
         glcd_pixel(i, i/2, 1) ;
       }   
     glcd_update () ;
      Delay_xS(4);
      
     _GLCD_ClearGraphics();
     _GLCD_DisableGraphics() ;
     
     sprintf(txt,(const rom unsigned char *)"Mode Grafique   "); 
    _GLCDWriteText(0, 0, txt);
     sprintf(txt,(const rom unsigned char *)"MPLAB C18 V3.45 "); 
     _GLCDWriteText(0, 1, txt);
     sprintf(txt,(const rom unsigned char *)"wxyz-=+-*/,:$*#"); 
     _GLCDWriteText(0, 2,txt);
     sprintf(txt,(const rom unsigned char *)"paulfjujo.free.f"); 
  	_GLCDWriteText(0, 3,txt);
    
    Delay_xS(4); 

   } 
} 

